; runalot v0.08x - EJN (blueznl)
; multi launcher, launch multiple instances of for example a browser with specific parameters
; bluez@xs4all.nl
;
#runalot_version = "v0.08x"
#runalot_copyright = "c2012 EJN"
;
EnableExplicit
IncludeFile("..\x_lib\x_lib.pb")
IncludeFile("..\g_spot\g_spot.pb")
Declare main()
Declare init()
;
x_init()
gs_init()
init()
main()
x_end()
gs_end()
End

Procedure history()                                        ; history                         
  ;
  ;
  ; *** history
  ;
  ; current
  ;
  ; - compiled with 4.61 beta 1
  ; - added auto path modification of executable for the '(x86') part when running on 64 bit windows
  ; - replaced .l with .i in callbackhandler for 64 bits support
  ;
  ; v0.04x
  ;
  ; - added commandline optiond load go quit
  ; - increased minimal width
  ; - increased default height
  ; - fixed some behaviour problems when using command line parameters
  ;
  ; v0.01x
  ;
  ; - first version
  ;
EndProcedure

Procedure init()                                           ; initialize and prepare          
  ;
  ;
  ; *** functions and menu entries
  ;
  ;
  Enumeration
    ;
    ; either real menu entries or logical functions triggered by gadgets or events
    ; grouped per window
    ;
    ; note 1: functions could be called from other windows / menus / buttons etc as well
    ; note 2: not all may (yet) be implemented
    ;
    ; *** functions
    ;
    #f_none                                     ; do nothing
    #f_load                                     ; load a set
    #f_save                                     ; save a set
    #f_exit                                     ; exit program
    #f_help                                     ; show help
    #f_run                                      ; run
    ;
  EndEnumeration
  ;
  ;
  ; *** windows and gadgets
  ;
  ;
  Enumeration #PB_Compiler_EnumerationValue
    ;
    ; windows
    ;
    #w_main_nr
    ;
    ; menus
    ;
    #m_main_nr
    ;
    ; toolbars
    ;
    #tb_main_nr
    ;
    ; status bars
    ;
    #sb_main_nr
    ;
    ; gadgets - main
    ;
    #g_executable_text
    #g_executable
    #g_executable_browse
    #g_parameters_text
    #g_parameters
    #g_first_pause_text
    #g_first_pause
    #g_next_pause_text
    #g_next_pause
    #g_batch_size_text
    #g_batch_size
    #g_translate_old_text
    #g_translate_old
    #g_translate_new_text
    #g_translate_new
    #g_run
    #g_inserts
    #g_inserts_text
    ;
  EndEnumeration
  ;
  ;
  ; *** images and icons
  ;
  ;
  Enumeration #PB_Compiler_EnumerationValue
    ;
    #i_exit
    #i_help
    #i_play_fastforward
    ;
  EndEnumeration
  ;
  DataSection
    ;
    i_exit_data:
    IncludeBinary "icons\exit_2.ico"
    i_help_data:
    IncludeBinary "icons\help.ico"
    i_play_fastforward:
    IncludeBinary "icons\play_fastforward.ico"
    ;
  EndDataSection
  ;
  ; image and icon handles
  ;
  ; load(ed) icons
  ;
  Global i_exit_h = CatchImage(#i_exit,?i_exit_data)
  Global i_help_h = CatchImage(#i_help,?i_help_data)
  Global i_play_fastforward_h = CatchImage(#i_play_fastforward,?i_play_fastforward)
  ;
  ; created icons
  ;
  ; images
  ;
  ; created images
  ;
  ; *** fonts
  ;
  Global font_size.i                ; keep font size
  ;
  ; placeholders for the preferences menu until applied or ok'ed
  ;
  ; *** other globals
  ;
  ; gui - components - windows, menus, toolbars etc.
  ;
  Global w_main_h.i, m_main_h.i, sb_main_h.i, tb_main_h.i
  ;
  ; gui - components - main
  ;
  ; gui - events and main loop
  ;
  Global action.i, event.i, event_type.i, event_menu.i, event_window.i, event_gadget.i
  ;
  ; other
  ;
  Global setname.s = GetPathPart(ProgramFilename())+"runalot.set"
  ;
  Global executable.s = "c:\Program Files\Mozilla Firefox\firefox.exe"
  Global parameters.s = "%1"
  Global first_pause.i = 2
  Global next_pause.i = 1
  Global batch_size.i = 20
  Global translate_old.s = " "
  Global translate_new.s = "+"
  Global inserts.s = "purebasic"+#CRLF$+"xs4all.nl/~bluez/purebasic/index.htm"
  Global old_inserts.s = inserts
  ;
  Global commands.s
  Global batch_counter.i
  Global first_run = #True
  ;
  Global helptext.s
  ;
  DataSection
    helptext:
    IncludeBinary "runalot.txt"
    Data.b 0, 0
  EndDataSection
  ;
EndProcedure

Procedure.s getkeyvalue(key.s)                                                               
  Protected x.s
  ;
  ; *** find the value for key 'key'
  ;
  ; in:        key.s   - string starting with underscore
  ; out:       .s      - associated string (if any)
  ;
  x = ""
  While x = "" And Not Eof(1)
    x = Trim(ReadString(1))
    If Left(x,1) <> "_"
      x = ""
    ElseIf x = key
      x = ""
      Break
    ElseIf StringField(x,1," ") = key
      x = Mid(x,FindString(x," ")+1)
    Else
      x = ""
    EndIf
  Wend
  ;
  ProcedureReturn x                                                                            
EndProcedure

Procedure data_load(filename.s)                                                              
  Protected result.i, x.s
  ;
  ; *** load a set
  ;
  ; load a complete dataset
  ;
  If filename = ""
    filename = OpenFileRequester("Open RunALot set",setname,"Set (*.set)|*.set|Any (*.*)|*.*",0)
  EndIf
  ;
  If x_exist(filename)
    result = #True
  Else
    ;
    ; try to create a valid name if the file did not exist
    ;
    If Right(LCase(filename),4)<>".set"
      If FindString(filename,".") <= 0
        filename = filename + ".set"
      EndIf
    EndIf
    If x_exist(filename)
      result = #True
    Else
      result = #False
    EndIf
  EndIf
  ;
  If result = #True
    setname = filename
    ReadFile(1,setname)
    ;
    executable = getkeyvalue("_executable")
    parameters = getkeyvalue("_parameters")
    first_pause = Val(getkeyvalue("_first_pause"))
    next_pause = Val(getkeyvalue("_next_pause"))
    batch_size = Val(getkeyvalue("_batch_size"))
    x = getkeyvalue("_translate")
    translate_old = Chr(Val(StringField(x,1," ")))
    translate_new = Chr(Val(StringField(x,2," ")))
    ;
    getkeyvalue("_inserts")
    inserts = ""
    While Not Eof(1)
      If inserts = ""
        inserts = ReadString(1)
      Else
        inserts = inserts + #LF$ + ReadString(1)
      EndIf
    Wend
    ;
    CloseFile(1)
    ;
    inserts = x_stringtostring(inserts,11)
    old_inserts = inserts
    ;
  EndIf
  ;
EndProcedure

Procedure data_save()                                                                        
  Protected result.i, filename.s
  ;
  ; *** save a set
  ;
  ; save a complete dataset
  ;
  filename = SaveFileRequester("Save RunALot set",setname,"Set (*.set)|*.set|Any (*.*)|*.*",0)
  If x_exist(filename)
    ;
    ; is it okay to overwrite if the file already exists?
    ;
    If MessageRequester("Save set","File "+filename+" already exists."+#LF$+#LF$+"Do you want to replace this file?",#PB_MessageRequester_YesNo|#MB_ICONWARNING) = #PB_MessageRequester_Yes
      result = #True
    Else
      result = #False
    EndIf
  ElseIf filename > "" And filename <> ".set"
    ;
    ; try to create a valid name if the file did not exist
    ;
    If Right(LCase(filename),4)<>".set"
      If FindString(filename,".") <= 0
        filename = filename + ".set"
      EndIf
    EndIf
    result = #True
  Else
    ;
    ; definitely an invalid name
    ;
    result = #False
  EndIf
  ;
  If result = #True
    If CreateFile(1,filename)
      WriteStringN(1,"_remark runalot setname: "+setname)
      WriteStringN(1,"")
      WriteStringN(1,"_executable "+executable)
      WriteStringN(1,"_parameters "+parameters)
      WriteStringN(1,"_first_pause "+Str(first_pause))
      WriteStringN(1,"_next_pause "+Str(next_pause))
      WriteStringN(1,"_batch_size "+Str(batch_size))
      WriteStringN(1,"_translate "+Str(Asc(translate_old))+" "+Str(Asc(translate_new)))
      WriteStringN(1,"")
      WriteStringN(1,"_inserts")
      WriteStringN(1,inserts)
      CloseFile(1)
      setname = filename
      old_inserts = inserts
    EndIf
  EndIf
EndProcedure

Procedure callback_handler(windowid.i,message.i,wparam.i,lparam.i)                           
  ;
  ; *** callback handler
  ;
  ; only used for grabbing tab key when inside the editor gadget
  ;
  Protected *nmhdr.NMHDR
  Protected *nmlvcustomdraw.NMLVCUSTOMDRAW
  Protected gadget_h.i, item_nr.i
  Select message
    Case #WM_NOTIFY
      *nmlvcustomdraw = lparam                              ; use to do custom drawing
      *nmhdr.NMHDR = lparam                                 ; use to grab tab key
      gadget_h = *nmhdr\hwndFrom                            ; handle of gadget that caused event
      If GetAsyncKeyState_(#VK_TAB) = 32768                 ; tab
        Select gadget_h
          Case GadgetID(#g_inserts)
            If GetAsyncKeyState_(#VK_SHIFT) = 32768             ; shifted tab
              SetActiveGadget(#g_run)
              ProcedureReturn 1                                                                            
            Else
              SetActiveGadget(#g_executable)
              ProcedureReturn 1                                                                            
            EndIf
        EndSelect
      EndIf
  EndSelect
  ProcedureReturn #PB_ProcessPureBasicEvents              ; continue processing messages       
EndProcedure

Procedure fields_set()                                                                       
  ;
  ; *** fill all fields (gadgets) with (user) data
  ;
  SetGadgetText(#g_executable,executable)
  SetGadgetText(#g_parameters,parameters)
  SetGadgetText(#g_first_pause,Str(first_pause))
  SetGadgetText(#g_next_pause,Str(next_pause))
  SetGadgetText(#g_batch_size,Str(batch_size))
  SetGadgetText(#g_translate_old,translate_old)
  SetGadgetText(#g_translate_new,translate_new)
  SetGadgetText(#g_inserts,inserts)
EndProcedure

Procedure fields_get()                                                                       
  ;
  ; *** read all data from (user) fields (gadgets)
  ;
  executable = GetGadgetText(#g_executable)
  parameters = GetGadgetText(#g_parameters)
  first_pause = Val(GetGadgetText(#g_first_pause))
  next_pause = Val(GetGadgetText(#g_next_pause))
  batch_size = Val(GetGadgetText(#g_batch_size))
  translate_old = GetGadgetText(#g_translate_old)
  translate_new = GetGadgetText(#g_translate_new)
  inserts = GetGadgetText(#g_inserts)
  ;
  ; calling fields_set() immediately after shows what user entered data turned into...
  ; for example entering non-numeric characters in numeric fields such as batchsize may result in value 0
  ;
  inserts = x_stringtostring(inserts,11)
  fields_set()
  ;
EndProcedure

Procedure gogo(x.s) 
  Protected shadow.s
  ;
  ; *** create and execute command lines
  ;
  ; assemble the command line and if there are enough parameters execute them
  ;
  If x > ""
    commands = commands + " "+#DQUOTE$+x+#DQUOTE$
    batch_counter = batch_counter+1
  EndIf
  ;
  If batch_counter >= batch_size
    If commands > ""                                         ; only execute if there is something to do
      If x_exist(executable)
        shadow = executable
      ElseIf FindString(LCase(executable),LCase("Program Files (x86)")) > 0
        shadow = ReplaceString(executable,"Program Files (x86)","Program Files",#PB_String_NoCase)
      Else
        shadow = ReplaceString(executable,"Program Files","Program Files (x86)",#PB_String_NoCase)
      EndIf  
      If x_exist(shadow)                                 ; only execute if executable exists
        RunProgram(#DQUOTE$+shadow+#DQUOTE$,commands,GetPathPart(shadow))
        If first_run
          Delay(first_pause*1000)
        Else
          Delay(next_pause*1000)
        EndIf
      EndIf
    EndIf
    batch_counter = 0
    commands = ""
    first_run = #False
  EndIf
  ;
EndProcedure

Procedure gogo_flushqueue()                                                                  
  batch_counter = batch_size
  gogo("")
EndProcedure

Procedure go()                                                                               
  Protected nn.i, x.s, n.i
  Protected command.s
  ;
  ; *** create and execute command lines
  ;
  ; find all entries that would result in command line parameters and pass them on to gogo()
  ;
  ; prepare
  ;
  n = CountString(inserts,#CR$)+1
  batch_counter = 0
  first_run = #True
  ;
  ; check 'parameters' field
  ;
  If FindString(parameters,"%1") <= 0
    gogo(parameters)
  EndIf
  ;
  ; process all lines in 'inserts' field
  ;
  nn = 0
  While nn < n
    nn = nn+1
    x = Trim(StringField(inserts,nn,#CR$))
    If x = ""
    ElseIf Left(x,7)  = "_remark"
    ElseIf Left(x,12) = "_executable "
      gogo_flushqueue()
      executable = Mid(x,13)
    ElseIf Left(x,5) = "_url "
      parameters = Mid(x,6)
      If FindString(parameters,"%1") <= 0
        gogo(parameters)
      EndIf
    ElseIf Left(x,12) = "_parameters "
      parameters = Mid(x,13)
      If FindString(parameters,"%1") <= 0
        gogo(parameters)
      EndIf
    ElseIf Left(x,11) = "_translate "
    ElseIf Left(x,8)  = "_inserts"
    ElseIf Left(x,11) = "_batchsize "
      gogo_flushqueue()
      batch_size = Val(Mid(x,12))
    ElseIf Left(x,11) = "_flushqueue"
      gogo_flushqueue()
    Else
      x = ReplaceString(x,translate_old,translate_new)
      x = ReplaceString(parameters,"%1",x)
      gogo(x)
    EndIf
  Wend
  ;
  ; make sure nothing stays behind
  ;
  If batch_counter > 0
    batch_counter = batch_size
    gogo("")
  EndIf
  ;
EndProcedure

Procedure draw()                                                                             
  Protected x.i, y.i, w.i, h.i, b.i
  ;
  ; *** draw all elements on screen
  ;
  ; only called once on program start
  ;
  ; see also:
  ;
  ;   fields_set()     - set all gadget values (aka fields)
  ;   fields_get()     - get all gadget values (aka fields)
  ;
  ;
  w_main_h = OpenWindow(#w_main_nr,10,10,400,440," RunALot "+#runalot_version+" - "+#runalot_copyright, #PB_Window_SystemMenu | #PB_Window_SizeGadget | #PB_Window_TitleBar | #PB_Window_ScreenCentered | #PB_Window_MaximizeGadget | #PB_Window_MinimizeGadget)
  WindowBounds(#w_main_nr,380,190,#PB_Ignore,#PB_Ignore)
  SetWindowCallback(@callback_handler(),#w_main_nr)
  SmartWindowRefresh(#w_main_nr,1)
  ;
  ; toolbar
  ;
  CreateToolBar(#tb_main_nr,w_main_h)
  ToolBarStandardButton(#f_load,#PB_ToolBarIcon_Open)
  ToolBarStandardButton(#f_save,#PB_ToolBarIcon_Save)
  ToolBarImageButton(#f_run,i_play_fastforward_h,#PB_ToolBar_Normal)
  ToolBarImageButton(#f_exit,i_exit_h,#PB_ToolBar_Normal)
  ToolBarImageButton(#f_help,i_help_h,#PB_ToolBar_Normal)
  ;
  ToolBarToolTip(#tb_main_nr,#f_load,"Open")
  ToolBarToolTip(#tb_main_nr,#f_save,"Save")
  ToolBarToolTip(#tb_main_nr,#f_run,"Go")
  ToolBarToolTip(#tb_main_nr,#f_exit,"Quit")
  ToolBarToolTip(#tb_main_nr,#f_help,"Help")
  ;
  AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F1,#f_help)
  AddKeyboardShortcut(#w_main_nr,#PB_Shortcut_F5,#f_run)
  ;
  b = 2
  x = 2
  y = ToolBarHeight(#tb_main_nr)+b
  w = WindowWidth(#w_main_nr)
  h = WindowHeight(#w_main_nr)
  ;
  ; default executable and browse button
  ;
  TextGadget(#g_executable_text,x,y+3,60,18,"Executable")
  StringGadget(#g_executable,x+60,y,w,20,"")
  ButtonGadget(#g_executable_browse,x,y,40,20,"...")
  y = y+20+5
  gs_rule(0,#gs_stretchparentright,#gs_gadget,#g_executable,#gs_window,#w_main_nr,40+b*4,0)
  gs_rule(0,#gs_rightof,#gs_gadget,#g_executable_browse,#gs_gadget,#g_executable,b*2,0)
  ;
  ; default parameters
  ;
  TextGadget(#g_parameters_text,x,y+3,60,18,"Parameters")
  StringGadget(#g_parameters,x+60,y,w,20,"")
  y = y+20+5
  gs_rule(0,#gs_stretchparentright,#gs_gadget,#g_parameters,#gs_window,#w_main_nr,b*2,0)
  ;
  ; pauses
  ;
  TextGadget(#g_first_pause_text,x,y+3,60,18,"First pause")
  StringGadget(#g_first_pause,x+60,y,40,20,"")
  TextGadget(#g_next_pause_text,x+110,y+3,60,18,"Next pause")
  StringGadget(#g_next_pause,x+172,y,40,20,"")
  y = y+20+5
  ;
  ; batch and translate
  ;
  TextGadget(#g_batch_size_text,x,y+3,60,18,"Batch size")
  StringGadget(#g_batch_size,x+60,y,40,20,"")
  TextGadget(#g_translate_old_text,x+110,y+3,60,18,"Translate")
  StringGadget(#g_translate_old,x+172,y,40,20,"")
  TextGadget(#g_translate_new_text,x+220,y+3,20,18,"to")
  StringGadget(#g_translate_new,x+242,y,40,20,"")
  y = y+20+10
  ;
  ; run
  ;
  ButtonGadget(#g_run,x,y,80,40,"Go")
  gs_rule(0,#gs_setx,#gs_gadget,#g_run,#gs_gadget,#g_executable_browse,-40,0)
  gs_rule(0,#gs_above,#gs_gadget,#g_run,#gs_gadget,#g_inserts,b*2,0)
  ;
  ; inserts
  ;
  TextGadget(#g_inserts_text,x,y,60,18,"Inserts (%1)")
  y = y+20
  x_editorgadget(#g_inserts,x,y,WindowWidth(#w_main_nr),WindowHeight(#w_main_nr)-ToolBarHeight(#tb_main_nr),"","",#x_gadget_notify)
  y = y+9999
  gs_rule(0,#gs_setwidth,#gs_gadget,#g_inserts,#gs_window,#w_main_nr,-b*2,32)
  gs_rule(0,#gs_stretchparentbottom,#gs_gadget,#g_inserts,#gs_window,#w_main_nr,b,32)
  ;
  
  gs_apply()
  fields_set()
  SetActiveGadget(#g_inserts)
  ;
EndProcedure

Procedure main_loop()                                                                        
  Protected filename.s, helptext.s
  ;
  ; *** main loop
  ;
  Repeat
    action = #f_none
    ;
    event = WaitWindowEvent()
    event_type = EventType()
    event_menu = EventMenu()
    event_gadget = EventGadget()
    event_window = EventWindow()
    ;
    Select event
      Case #PB_Event_MoveWindow, #PB_Event_SizeWindow
        gs_apply()
      Case #PB_Event_CloseWindow
        action = #f_exit
      Case #PB_Event_Menu
        action = event_menu
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #g_executable_browse
            filename = OpenFileRequester("Select executable","","Executable (*.exe)|*.exe",0)
            If x_exist(filename)
              executable = filename
              SetGadgetText(#g_executable,executable)
            EndIf
          Case #g_run
            action = #f_run
        EndSelect
    EndSelect
    ;
    Select action
      Case #f_load
        data_load("")
        fields_set()
      Case #f_save
        fields_get()
        fields_set()
        data_save()
      Case #f_run
        fields_get()
        go()
      Case #f_help
        HideWindow(#w_main_nr,#True)
        x_littlehelp(" RunALot "+#runalot_version+" - "+#runalot_copyright,"",?helptext,#PB_Ascii)
        HideWindow(#w_main_nr,#False)
        SetActiveWindow(#w_main_nr)
      Case #f_exit
    EndSelect
  Until action = #f_exit
  ;
EndProcedure

Procedure main()                                                                             
  Protected x.s, n.i, nn.i
  ;
  ; *** main code
  ;
  ; three stage approach:
  ;
  ; 1. do whatever needs to be done at program start
  ; 2. do the endless loop
  ; 3. do whatever needs to be done at program end
  ;
  ; initializing and clean up of libraries is done at the top of the code
  ;
  x = LCase(ProgramParameter(0))
  ;
  n = CountProgramParameters()
  nn = 0
  While nn < n
    x = ProgramParameter(nn)
    Select x
      Case "load"
        nn = nn+1
        setname = ProgramParameter(nn)
        data_load(setname)
      Case "go"
        data_load(setname)
        go()
      Case "quit"
        nn = n
      Case "help", "-h"
        nn = n
    EndSelect
    nn = nn+1
  Wend
  ;
  Select x
    Case "quit"
    Case "help", "-h"
      Restore helptext
      Read.s helptext
      x_littlehelp("RunALot "+#runalot_version,helptext,0)
    Default
      ;
      ; except for 'quit' or 'help' we'll end up here
      ;
      draw()
      data_load(setname)
      fields_set()
      fields_get()
      ;
      main_loop()
      ;
      fields_get()
      If inserts <> old_inserts
        data_save()
      EndIf
      ;
  EndSelect
  ;
EndProcedure

; IDE Options = PureBasic 4.61 Beta 1 (Windows - x86)
; CursorPosition = 6
; Folding = AA9
; EnableXP
; UseIcon = icons\play_fastforward.ico
; Executable = runalot.exe
; CommandLine = load f:\dropbox\private\runalot.set
; CurrentDirectory = C:\software\purebasic\_projects\
; DisableCompileCount = 2
; DisableBuildCount = 1
; EnableExeConstant